function InsertFunctionHeader()
    local line, pos = editor:GetCurLine()
    local pos = editor.CurrentPos - pos
    local lineNum = editor:LineFromPosition(pos)
-- "()([Ff][Uu][Nn][Cc][%s]*([%w_]*)%(.-%))([^\r\n]*)"
--  local from, to, name = string.find(line, "Func ([%w_]*)")
    local from, to, name = string.find(line, "[Ff][Uu][Nn][Cc][%s]*([%w_]*)")
    if to ~= nil then
--      local pfrom, pto, pname = string.find(line, "(%([%w%s\"_,$%=@-%.]*[%)_])")
        local pfrom, pto, pname = string.find(line, "(%(.-%))")
        local i = 0
        while string.find(pname, "_%s*$") do    -- Found an underscore, so need to get the next line, too
            i = i + 1
            local tmp = editor:GetLine(lineNum+i)
            local wfrom = string.find(pname, "_%s*$")
            local nfrom = string.find(tmp, "[^%s]")
            pname = string.sub(pname, 1, wfrom-1) .. string.sub(tmp, nfrom, -1)
            pname =  string.gsub(pname, "[\n\r]", "")
        end
        editor:Home()

        editor:AddText(_CreateFunctionHeader(name,pname))
    else
        local ws = editor:WordStartPosition(editor.CurrentPos)
        local we = editor:WordEndPosition(editor.CurrentPos)
        local word = editor:textrange(ws, we)
        -- Must strip the new lines for this to work.
        line = string.gsub(line, "[\n\r]", "")
        word = string.gsub(word, "[\n\r]", "")
        if word == "" then
            editor:AddText(_CreateFunctionHeader("Name", ""))
        elseif word == line then
            editor:LineEnd()
            local lend = editor.CurrentPos
            editor:Home()
            local lstart = editor.CurrentPos
            editor:SetSel(lstart, lend)
            editor:ReplaceSel(_CreateFunctionHeader(word, "") .. "Func " .. word .. "()\r\nEndFunc; " .. word)
         end
    end
end -- InsertFunctionheader()
function _CreateFunctionHeader(s, p)
    local res = ";#Function# " .. string.rep("=", 140) .. "\r\n; Name............: " .. s .. "\r\n; Description.....:\r\n; Syntax..........: ".. s .. p .."\r\n; Parameters......:"
    local len = nil
	local params = false
    for byref, parameter, optional in string.gfind(p, "(%w-)%s*($[%w_]+)%s*([=]?)") do
        if parameter ~= "" and parameter ~= nil then
            params = true
            if byref ~= "" and byref ~= nil then
                len = string.len(parameter)
				res = res .. "\r\n;" .. string.rep(" ", 19) .. parameter .. string.rep(" ", 13-len).. "\ IN/OUT - "
            elseif optional ~= "" and optional ~= nil then
                len = string.len(parameter)
				res = res .. "\r\n;" .. string.rep(" ", 19) .. parameter .. string.rep(" ", 13-len).."- [optional]  "
            else
                len = string.len(parameter)
				res = res .. "\r\n;" .. string.rep(" ", 19) .. parameter .. string.rep(" ", 13-len).."- "
            end
        end
    end
    if params == false then
        res = res .. "\r\n;\tNone."
    end
    res = res .. "\r\n; Return values  .:\r\n;                   Success\t\t -\r\n;                   Failure\t\t -\r\n\; Author ........:  Raupi@Autoit.de\r\n; Modified.......:\r\n"
	res = res .. "; Remarks .......:\r\n; Related .......:\r\n; Link ..........;\r\n; Example .......;\r\n" .. "; " .. string.rep("=", 150) .. "\r\n"
    return res
end -- _CreateFunctionHeader()
